import { world, system, ItemStack} from '@minecraft/server'
export const PlayerGunsData = {}
export function initializePlayerData (player) {
    let id = player.id
    if (!PlayerGunsData.hasOwnProperty(id)) {
        PlayerGunsData[id] = {
            isUsing: false,
            isReloading: false,
            guns: {}
        }
    }
}

export function setUpGunsData (player, item, isUsing, index) {
    let id = player.id
    let gunId = item.getDynamicProperty("L4gg-gunId")
    let ammo = item.getDynamicProperty("L4gg-ammo")
    PlayerGunsData[id].guns[gunId] = new GunData(ammo)
}

 class GunData {
	constructor (ammoCount, index) {
		this.currentAmmo = ammoCount,
		this.currentCooldown = 0,
		this.index = index
	}
}

