import { world, system } from '@minecraft/server'
import { ModalFormData, ModalFormResponse } from '@minecraft/server-ui';
import {PlayerGunsData} from "./PlayerGunsData.js"
world.afterEvents.itemStartUse.subscribe(({itemStack, source, useDuration}) => {
    
    if (itemStack.typeId !== "l4gg:gun_debug") return
    debug (source)
})


function debug (player) {

    const form = new ModalFormData()
    form.title("Guns Dev Tool")
    form.textField("Run Command", "")
    form.show (player).then(result => {
        try {
            let commandText = result.formValues[0]
            if (Commands.hasOwnProperty(commandText)) {
                Commands[commandText]()
            }
            
        } catch (e) {
            console.warn(e)
        }
    })
}
const Commands = {
    printAllDynamicProperties () {
        let propertyIds = world.getDynamicPropertyIds()
        world.sendMessage("[Debug] World Dynamic Properties List: ")
        for (let id of propertyIds) {
            let value = world.getDynamicProperty(id)
            world.sendMessage(id+" - "+value)
        }
    },
    reset () {
        world.setDynamicProperty("GunAddonVersion", undefined)
    },
    printGunsData () {
        let gunData = JSON.stringify(PlayerGunsData, null, 2)
        world.sendMessage(gunData)
    },
    printMovement() => {
        let player = world.getAllPlayers()[0]
        let movementComponent = player.getComponent("movement")
        for (let i in movementComponent) {
            world.sendMessage(i)
        }
    }
    
}