import { world, system, ItemStack} from '@minecraft/server'
//import {PlayerEquipment} from "../playerComponents.js"
import {Guns} from "../Guns.js"
import {PlayerGunsData} from "../PlayerGunsData.js"
import {ReloadTypes} from "./reloadSystem.js"
export function updateAmmo (player, item, gunData) {
    let gameMode = player.getGameMode
    if (gameMode != "creative" && !player.hasTag("infinite")) {
        gunData.currentAmmo--
    }
    if (gunData.currentAmmo > 0) return
    if (ReloadTypes.hasOwnProperty(item.typeId)) {
        return
    }
    let emptyGun = new ItemStack (item.typeId+"_empty", 1)
    const gunId = item.getDynamicProperty("L4gg-gunId")
    const slot = PlayerGunsData[player.id].guns[gunId].index
    emptyGun.setDynamicProperty("L4gg-gunId", gunId)

    setItemAtSlot(player, slot, emptyGun)
    PlayerGunsData[player.id].isUsing = false
    
}

function setItemAtSlot(player, slot, item) {
    const inventory = player.getComponent("inventory").container
    inventory.setItem(slot, item)
}
