import { world, system} from '@minecraft/server'
import {VECTOR} from "../mathUtils.js"
import {Guns} from "../Guns.js"

import {ReloadTypes} from "./reloadSystem.js"

export function setMovement (player, item) {
    if (!item) {
        removeEffect (player)
        return 
    }
    const typeId = item.typeId.split("_")[0]
    if (!ReloadTypes.hasOwnProperty(typeId) && !Guns.hasOwnProperty(typeId)) {
        removeEffect (player)
        return
    }
    const movement = player.getComponent("movement")
    if (player.isSneaking) {
        onSneak (player, typeId)
    } else {
        onHold (player, typeId)
    
    }
}

function removeEffect (player) {
    let hasSlowness = player.getDynamicProperty("hasSlowness")
    if (!hasSlowness) return
    player.runCommand("effect @s slowness 0 0")
    player.setDynamicProperty("hasSlowness", undefined)
}
function onSneak (player, typeId) {
    const value = Guns[typeId].movementSlowness.sneaking
    if (!value) return
        player.runCommand(`effect @s slowness 2 ${value} true`)
        player.setDynamicProperty("hasSlowness", true)
}
function onHold (player, typeId) {
    const value = Guns[typeId].movementSlowness.hold
    if (!value) {
        removeEffect (player)
        return
    }
    player.runCommand(`effect @s slowness 2 ${value} true`)
    player.setDynamicProperty("hasSlowness", true)
}