import { world, system, ItemStack} from '@minecraft/server'
import {VECTOR} from "../mathUtils.js"
import {Guns} from "../Guns.js"


export function shoot (player, item) {
    const GunInfo = Guns[item.typeId]
    if (!GunInfo) {
        return 
    }
    let bulletId = GunInfo.projectile.id
    let power = GunInfo.projectile.power
    let bulletCount = GunInfo.projectile.count
    let velocity = player.getVelocity()
    let bulletLocation = player.getHeadLocation()
    bulletLocation = VECTOR.addWithVector(bulletLocation, velocity)
    for (let i = 0; i < bulletCount; i++) {
        
        let bullet = player.dimension.spawnEntity(bulletId, bulletLocation)
        setUpProjectile (bullet, player, item)
    }
}

function setUpProjectile (bullet, player, item) {
    let info = Guns[item.typeId].projectile
    let power = info.power
    let projectileCompt = bullet.getComponent("projectile")
    projectileCompt.owner = player
    let direction = player.getViewDirection()
    direction = VECTOR.multiplyByNum(direction, power)
    projectileCompt.shoot(direction, {uncertainty: info.uncertainty})
    const removeHitAmunity = world.getDynamicProperty("removeHitAmunity")
    bullet.nameTag = player.name
    if (removeHitAmunity) return
    bullet.triggerEvent("adn:full_damage")
}
