import { world, system } from '@minecraft/server'
import { ModalFormData, ModalFormResponse } from '@minecraft/server-ui';
const DynamicPropertiesValues = {
    "removeHitAmunity": false
}
const PropertyInfo = [
        {
        id: "removeHitAmunity",
        label: "Custom Damage System (experemental)\n - removes hit amunity\n - custom knockback strength",
        formType: "toggle"
    }
]

world.afterEvents.itemStartUse.subscribe(({itemStack, source, useDuration}) => {
    
    if (itemStack.typeId !== "l4gg:gun_settings") return
    settings (source)
})
function updateDynamicPropertiesValues() {
    for (let prop in DynamicPropertiesValues) {
        let value = world.getDynamicProperty(prop)
        DynamicPropertiesValues[prop] = value
    }
}
export function settings (player) {
    updateDynamicPropertiesValues()
    const form = new ModalFormData()
    form.title("Guns+ Addon Settings")
    //form.submitButton("Apply Changes")
    for (let property of PropertyInfo) {
        let currentValue
        switch (property.formType) {
            case "dropDown":
                currentValue = DynamicPropertiesValues[property.id]
                let index = property.values.indexOf(currentValue)
                form.dropdown(property.label, property.ValuesLabel , index)
                break;
            case "toggle": 
                currentValue = DynamicPropertiesValues[property.id]
                form.toggle(property.label, currentValue)
                break;
        }
    }
    form.show (player).then(result => {
        
        if (result.formValues) {
            for (let i in result.formValues) {
                let propertyId = PropertyInfo[i].id
                let value = result.formValues[i]
                updateDynamicProperty(i, propertyId, value)
            }
        }
    })
}
function updateDynamicProperty(i, id, result) {
    let propertyInfo = PropertyInfo[i]
    let newValue = result
    let valueLabel = newValue
    if (propertyInfo.formType == "dropDown") {
        newValue = propertyInfo.values[result]
        valueLabel = propertyInfo.ValuesLabel[result]
        
    }
    let oldValue = DynamicPropertiesValues[id]
    if (oldValue == newValue) return
    let propertyId = propertyInfo.id
    world.setDynamicProperty(propertyId, newValue)
    
    world.sendMessage(`§2§l[Guns+] §6§r${propertyInfo.label} Has Been Set To `+valueLabel)
    
}



