import { world, system, ItemStack} from '@minecraft/server'
import { ActionFormData, ActionFormResponse} from '@minecraft/server-ui';
import {VECTOR} from "./mathUtils.js"

const VERSION = 2
world.afterEvents.worldInitialize.subscribe(() => {
    let addonVersion = world.getDynamicProperty("GunAddonVersion")
    if (addonVersion == VERSION) return
    const RunId = system.runInterval (() => {
        const players = world.getAllPlayers()
        for (let player of players) {
            let isActive = isPlayerActive(player)
            if (isActive) {
                initialize()
                system.clearRun(RunId)
                return
            }
        }
    })
})
function initialize () {
    world.setDynamicProperty ("GunAddonVersion", VERSION)
    setUpSettings ()
    setUpScoreboard ()
    world.sendMessage("§l Guns+ Addon created by mcpedl: L4ggcrafter, youtube: ned2z")
}


function setUpSettings () {
    world.setDynamicProperty("removeHitAmunity", true)
    
}
function setUpScoreboard () {
    let objective = world.scoreboard.getObjective("L4gg-armorPoints")
    if (objective) return
    world.scoreboard.addObjective("L4gg-armorPoints", "Armor Points")
    
}
function isPlayerActive(player) {
	let rot = player.getRotation()
	let velocity = player.getVelocity()
	velocity = VECTOR.getMagnitude(velocity)
	return velocity > 0.001 || Math.abs(rot.x) > 1
}