//By L4ggcrafter
import { world, system, ItemStack} from '@minecraft/server'
import {shoot} from "./gunFunctions/shootProjectile.js"
import {playEffects} from "./gunFunctions/specialEffects.js"
import {PlayerGunsData, setUpGunsData} from "./PlayerGunsData.js"

import {PlayerEquipment} from "./playerComponents.js"
import {reloadGun} from "./gunFunctions/reloadSystem.js"
import {Guns} from "./Guns.js"
world.afterEvents.itemUse.subscribe(({itemStack, source, useDuration}) => {
    
    if (Guns.hasOwnProperty(itemStack.typeId)) {
        intializeGun(source, itemStack)
        PlayerGunsData[source.id].usingSlot = source.selectedSlotIndex
    }
})

world.afterEvents.itemStopUse.subscribe(({itemStack, source, useDuration}) => {
//console.warn("gunStop")
    if (Guns.hasOwnProperty(itemStack.typeId)) {
        onGunStopUse(source, itemStack)
    }

})
world.afterEvents.itemReleaseUse.subscribe(({itemStack, source, useDuration}) => {
    let useTime = 400 - useDuration
    if (useTime < 2) return
    reloadGun(source, itemStack)
    //console.warn(useDuration)
})

export function onGunStopUse (player, item) {
    //const item = getItemAtSlot(player, PlayerGunsData[player.id].usingSlot)
    const gunId = item.getDynamicProperty("L4gg-gunId")
    const slot = PlayerGunsData[player.id].guns[gunId].index
    PlayerGunsData[player.id].isUsing = false
    //PlayerGunsData[player.id].usingSlot = null
    
    const ammo = PlayerGunsData[player.id].guns[gunId].currentAmmo
    if (ammo > 0) {
        item.setDynamicProperty("L4gg-ammo", ammo)
        //item.setLore(["ammo: "+system.currentTick])
        setItemAtSlot(player, slot, item)
        //world.sendMessage("id: "+gunId+" slot:"+slot)
    } else {
        let emptyGun = new ItemStack (item.typeId+"_empty", 1)
        emptyGun.setDynamicProperty("L4gg-gunId", gunId)
        //setItemAtSlot(player, slot, emptyGun)
    }
}

function intializeGun (player, item) {
    //setGunId (player, item)
    if (PlayerGunsData[player.id]?.isUsing) return; // Prevent initialization if a gun is already in use
    let ammo = item.getDynamicProperty("L4gg-ammo")
    let gunId = item.getDynamicProperty("L4gg-gunId")
    let isInitialized = PlayerGunsData[player.id]?.guns?.hasOwnProperty(gunId)
    if (!isInitialized) {
        setUpGunsData(player, item, true, player.selectedSlotIndex)
    }
    PlayerGunsData[player.id].isUsing = true
    PlayerGunsData[player.id].guns[gunId].index = getItemIndex (player,gunId)
    //player.selectedSlotIndex
}



export function setGunId (player, item) {
    let itemId = item.getDynamicProperty("L4gg-gunId")
    if (itemId) return
    let id = world.getDynamicProperty("L4gg-gunId") || 0
    id++
    world.setDynamicProperty("L4gg-gunId", id)
    item.setDynamicProperty("L4gg-gunId", id)
   // PlayerEquipment.setItemHold(player, item)
    
}
function setItemAtSlot(player, slot, item) {
    const inventory = player.getComponent("inventory").container
    inventory.setItem(slot, item)
}
function getItemIndex (player, id) {
    const inventory = player.getComponent("inventory").container
    for (let i = 0; i < 8; i++) {
        let item = inventory.getItem(i)
        if (!item) continue
        let gunId = item.getDynamicProperty("L4gg-gunId")
        if (gunId == id) return i
    }
    return 8
}